//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "MyOpRx1.h"
#include "MyOpRx2.h"
#include "MyOpRx3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm3 *Form3;
//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm3::CheckBox1Click(TObject *Sender)
{
 try{
  if(CheckBox1->Checked)ClientSocket1->Open();
  else ClientSocket1->Close();
  }catch(...){}
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Error(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
 StatusBar1->SimpleText="Socket Error: "+AnsiString(ErrorCode);
 ErrorCode=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Connect(TObject *Sender,
      TCustomWinSocket *Socket)
{
  StatusBar1->SimpleText="Connect to "+Socket->RemoteAddress;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Connecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
 StatusBar1->SimpleText="Connecting to "+Socket->RemoteAddress+" ...";
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Disconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
 StatusBar1->SimpleText="Disconnect";
}
//---------------------------------------------------------------------------
void __fastcall TForm3::FormClose(TObject *Sender, TCloseAction &Action)
{
  Form1->OperaChatSpots1->Checked=false;      
}
//---------------------------------------------------------------------------
void __fastcall TForm3::FormCreate(TObject *Sender)
{
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
  ClientSocket1->Address=ini->ReadString("OPERA_CHAT","ADDRESS","144.76.158.174");
  ini->WriteString("OPERA_CHAT","ADDRESS",ClientSocket1->Address);
  ClientSocket1->Port =ini->ReadInteger("OPERA_CHAT","PORT",8000);
  ini->WriteInteger("OPERA_CHAT","PORT",ClientSocket1->Port);
  CheckBox1->Checked=ini->ReadBool("OPERA_CHAT","ACTIVE",true);
  ini->WriteBool("OPERA_CHAT","ACTIVE",Form3->CheckBox1->Checked);
  mycall=ini->ReadString("OP-32","MYCALL", "");
  myqth=ini->ReadString("OP-32","MYQTH", "");
  reverse_output=ini->ReadBool("OP-32","REVERSE_OUTPUT",true);
  LogFileName=ini->ReadString("OPERA_CHAT","LOG_FILE_NAME","opera_log.txt");
  ini->WriteString("OPERA_CHAT","LOG_FILE_NAME",LogFileName);
  SaveOperaSpotstologfile1->Checked=ini->ReadBool("OPERA_CHAT","LOG_ENABLE",true);
  ini->WriteBool("OPERA_CHAT","LOG_ENABLE",SaveOperaSpotstologfile1->Checked);
  bool b=ini->ReadBool("PSKREPORTER","UPLOAD_SPOT",true);
  if(b) CheckBox2->Enabled=true; else CheckBox2->Enabled=false;
 delete ini;
 AnsiString sdate;
 time_t t=time(NULL);
     struct tm *t_cur;
      t_cur=gmtime(&t);
 sdate.sprintf("*********** %02u/%02u/%04u ***********",t_cur->tm_mday,t_cur->tm_mon+1,t_cur->tm_year+1900);
 Memo1->Font->Color=clFuchsia;
 Memo1->Lines->Add(sdate);
 Memo1->Font->Color=clNavy;
 Memo2->Lines->Add(">");
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Button1Click(TObject *Sender)
{
    AnsiString Msg;
    Edit1->Text.Trim();
    Msg="CHAT OPERA 136.0#"+Edit1->Text+"#"+Edit2->Text+"\n";
    Edit2->Text="";
    try{
     if(!ClientSocket1->Active)
     {
      ClientSocket1->Open();
      //ClientSocket1->Socket->SendText(mycall+"\n");
      CheckBox1->Checked=true;
     }
     ClientSocket1->Socket->SendText("JOIN OPERA\n");
     ClientSocket1->Socket->SendText(Msg);
    }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Button2Click(TObject *Sender)
{
    AnsiString Msg;
    Msg="CHAT OPERA 136.0#ALL#"+Edit2->Text+"\n";
    Edit2->Text="";
     try{
     if(!ClientSocket1->Active)
     {
      ClientSocket1->Open();
      //ClientSocket1->Socket->SendText(mycall+"\n");
      CheckBox1->Checked=true;
     }
     ClientSocket1->Socket->SendText("JOIN OPERA\n");
     ClientSocket1->Socket->SendText(Msg);
    }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Timer1Timer(TObject *Sender)
{
 if(CheckBox1->Checked)
 {
   try{
    if(!ClientSocket1->Active)
    { ClientSocket1->Open();
      //ClientSocket1->Socket->SendText(mycall+"\n");
      //ClientSocket1->Socket->SendText("JOIN OPERA\n");
    }
   }catch(...){}
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm3::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
 AnsiString s=Socket->ReceiveText();
 s=s.Trim();
 StatusBar1->SimpleText=s;
 if(s.Pos("LOGIN:")>0 || s.Pos("login:")>0)
 {ClientSocket1->Socket->SendText(mycall+"\n");
  ClientSocket1->Socket->SendText("JOIN OPERA\n");
  ClientSocket1->Socket->SendText("set/qra "+myqth+"\n");
  StatusBar1->SimpleText="login";
 }

  int spos=1;  int slength=s.Length();
  while(spos<slength)
  {AnsiString s1;
   bool delimeterfound=false;
   for(int i=spos; i<=slength; i++)
     if(s.IsDelimiter("\n\r\a\x7\x0",i))
     {s1=s.SubString(spos,i-spos); spos=i; delimeterfound=true; break;}
   if(!delimeterfound){s1=s.SubString(spos,slength-spos+1);spos=slength; if(s1==NULL) break;}
   spos++;

   if(s1.Pos("OPERA de ")>0)
   {//    
    AnsiString s2;
    int pos136=s1.Pos(" 136.0#");
    if(pos136<1) continue; //    
    
    int pos_decall_1=s1.Pos("OPERA de ")+9; // 
    int pos_decall_2=s1.Pos(": 136.0#"); //  
    AnsiString decall=s1.SubString(pos_decall_1,pos_decall_2-pos_decall_1); //callsign    -
    decall.Trim();

    s2=s1.SubString(pos_decall_2+8,20);
    int len2=s2.Pos("#");
    AnsiString callto=s1.SubString(pos_decall_2+8,len2-1); //  -  
    callto.Trim();

    int pos_rep=s1.Pos("#SWL-Op32");
    if(pos_rep>0) //  ,      
    {
     AnsiString report;
     report=s1.SubString(pos_rep+10,s1.Length()-pos_rep-10+1);
     for(int i=1; i<=report.Length(); i++)// if(report.IsDelimiter("\n\r\a",i)) report.Delete(i,1);
     {AnsiString rr=report.SubString(i,1);
      unsigned char rc[3]; strncpy(rc,rr.c_str(),2);
      if(rc[0]<0x20) {report=report.SubString(1,i-1);break;}
     }
     report.Trim();
     time_t t=time(NULL);
     struct tm *t_cur;
      t_cur=gmtime(&t);
     AnsiString fstr;
     fstr.sprintf("%02u:%02u:%02u %s de %s Op32 %s",t_cur->tm_hour,t_cur->tm_min,t_cur->tm_sec,callto,decall,report);
     if(decall==mycall)
       fstr.sprintf("%02u:%02u:%02u %s de %s Op32 %s",t_cur->tm_hour,t_cur->tm_min,t_cur->tm_sec,callto,decall,report);
    if(reverse_output) Memo1->Lines->Insert(0,fstr);
    else Memo1->Lines->Add(fstr);
    }
    else
    { //   
     AnsiString msg;
     int s1len=s1.Length();
     AnsiString scall= "#"+callto+"#";
     int pos_msg=s1.Pos(scall) + scall.Length();
     msg=s1.SubString(pos_msg,s1len-pos_msg+1);
     msg.Trim();
     time_t t=time(NULL);
     struct tm *t_cur;
      t_cur=gmtime(&t);
     AnsiString fstr;
     if(callto=="ALL")
     { fstr.sprintf("%02u:%02u %s > %s",t_cur->tm_hour,t_cur->tm_min,decall,msg);
       Memo2->Font->Color=clBlue;
       //if(reverse_output) Memo2->Lines->Insert(0,fstr);
       //else Memo2->Lines->Add(fstr);
        Memo2->Lines->Add(fstr);
     }
     if(callto==mycall)
     {fstr.sprintf("%02u:%02u %s de %s > %s",t_cur->tm_hour,t_cur->tm_min,callto, decall,msg);
      Memo2->Font->Color=clRed;
      if(reverse_output) Memo2->Lines->Insert(0,fstr);
      else Memo2->Lines->Add(fstr);
      AnsiString caption1="Message from "+decall;
     // MessageBox(NULL,msg.c_str(),caption1.c_str(),MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
      Edit1->Text=decall;
     }
    }
   }
  }
}
//---------------------------------------------------------------------------


void TForm3::sendOperaSpot(AnsiString call, AnsiString mycall, AnsiString report)
{
 AnsiString s;
 s="CHAT OPERA 136.0#"+call+"##SWL-Op32  "+report+"\n";
  try{
     if(!ClientSocket1->Active)
     {
      ClientSocket1->Open();
      ClientSocket1->Socket->SendText(mycall+"\n");
      ClientSocket1->Socket->SendText("JOIN OPERA\n");
     }
     ClientSocket1->Socket->SendText(s);
    }catch(...){}
}

//---------------------------------------------------------------------------


void __fastcall TForm3::SelectAll1Click(TObject *Sender)
{
 Memo1->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::CopytoClipboard1Click(TObject *Sender)
{
 Memo1->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::EraseAll1Click(TObject *Sender)
{
 Memo1->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Select1Click(TObject *Sender)
{
 Memo2->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::CopytoClipboard2Click(TObject *Sender)
{
  Memo2->CopyToClipboard();   
}
//---------------------------------------------------------------------------

void __fastcall TForm3::EraseAll2Click(TObject *Sender)
{
 Memo2->Clear();
}
//---------------------------------------------------------------------------


void __fastcall TForm3::CheckBox2Click(TObject *Sender)
{
 if(CheckBox2->Checked != Form1->UploadSpotstoOPERAcluster1->Checked)
  Form1->UploadSpotstoOPERAcluster1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Selectlogfile1Click(TObject *Sender)
{
 SaveDialog1->Execute();
 if(SaveDialog1->FileName==NULL) return;
 LogFileName=SaveDialog1->FileName;
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
 ini->WriteString("OPERA_CHAT","LOG_FILE_NAME",LogFileName);
 delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm3::SaveOperaSpotstologfile1Click(TObject *Sender)
{
 if(SaveOperaSpotstologfile1->Checked)SaveOperaSpotstologfile1->Checked=false;
 else SaveOperaSpotstologfile1->Checked=true;
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
 ini->WriteBool("OPERA_CHAT","LOG_ENABLE",SaveOperaSpotstologfile1->Checked);
 delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Memo1Change(TObject *Sender)
{
 if(SaveOperaSpotstologfile1->Checked) Memo1->Lines->SaveToFile(LogFileName);        
}
//---------------------------------------------------------------------------

void __fastcall TForm3::HelpRus1Click(TObject *Sender)
{
 AnsiString s;
 s=" OPERA CHAT     .\n";
 s=s+"     Connect\n";
 s=s+"      Upload\n";
 s=s+"\n  ,    (Send to ALL)\n";
 s=s+" - ,       Call (Send PRIVATE).\n";
 s=s+"\n     -: File->Save Opera Spots to log-file\n";
 s=s+" -    File->Select log-file...\n";
 MessageBox(NULL,s.c_str(),"Op32Rx Chat Help",MB_OK|MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

void __fastcall TForm3::FontBold1Click(TObject *Sender)
{
 if(FontBold1->Checked) FontBold1->Checked=false;
 else FontBold1->Checked=true;

 if(FontBold1->Checked) Memo1->Font->Style= TFontStyles()<< fsBold;
 else  Memo1->Font->Style= TFontStyles();

}
//---------------------------------------------------------------------------




